#ifndef CPSE_MATHOPS_H
#define CPSE_MATHOPS_H

namespace cpse {
namespace math {

struct unop_copy {};
struct unop_negate {};
struct unop_inverse {};
struct unop_transpose {};
struct unop_adjoint {};
struct unop_wdiv {}; // perspective division 4x1 -> 3x1
struct unop_normalize {}; // normalize vector
struct unop_slice {}; // part of a matrix
struct unop_translation {}; // make a translation matrix
struct unop_scaling {}; // make a scaling matrix
template<int R, int C> struct unop_cofactor {}; // remove row R and column C

struct binop_mul {};
struct binop_div{};
struct binop_add {};
struct binop_sub {};
struct binop_cross {}; // explicit vector product
struct binop_expand {}; // add element(s) to vector
struct binop_rotation {}; // make a rotation matrix

} // namespace math
} // namespace cpse

#endif
