// assignment for elementwise expressions

namespace cpse {
namespace math {

template<int> struct assign_elop_handler {};

// implemented like this instead of with a recursive template in order to
// help the optimizer and to minimize "debugging bloat"

template<> struct assign_elop_handler<16> {
	template<class T, class U> static void go(T &d, U a);
};

template<> struct assign_elop_handler<12> {
	template<class T, class U> static void go(T &d, U a);
};

template<> struct assign_elop_handler<9> {
	template<class T, class U> static void go(T &d, U a);
};

template<class T, class U>
void assign_elop_handler<16>::go(T &d, U a)
{
	d.data()[0] = a.template element<0>();
	d.data()[1] = a.template element<1>();
	d.data()[2] = a.template element<2>();
	d.data()[3] = a.template element<3>();
	d.data()[4] = a.template element<4>();
	d.data()[5] = a.template element<5>();
	d.data()[6] = a.template element<6>();
	d.data()[7] = a.template element<7>();
	d.data()[8] = a.template element<8>();
	d.data()[9] = a.template element<9>();
	d.data()[10] = a.template element<10>();
	d.data()[11] = a.template element<11>();
	d.data()[12] = a.template element<12>();
	d.data()[13] = a.template element<13>();
	d.data()[14] = a.template element<14>();
	d.data()[15] = a.template element<15>();
}

template<class T, class U>
void assign_elop_handler<12>::go(T &d, U a)
{
	d.data()[0] = a.template element<0>();
	d.data()[1] = a.template element<1>();
	d.data()[2] = a.template element<2>();
	d.data()[3] = a.template element<3>();
	d.data()[4] = a.template element<4>();
	d.data()[5] = a.template element<5>();
	d.data()[6] = a.template element<6>();
	d.data()[7] = a.template element<7>();
	d.data()[8] = a.template element<8>();
	d.data()[9] = a.template element<9>();
	d.data()[10] = a.template element<10>();
	d.data()[11] = a.template element<11>();
}

template<class T, class U>
void assign_elop_handler<9>::go(T &d, U a)
{
	d.data()[0] = a.template element<0>();
	d.data()[1] = a.template element<1>();
	d.data()[2] = a.template element<2>();
	d.data()[3] = a.template element<3>();
	d.data()[4] = a.template element<4>();
	d.data()[5] = a.template element<5>();
	d.data()[6] = a.template element<6>();
	d.data()[7] = a.template element<7>();
	d.data()[8] = a.template element<8>();
}

template<> struct assign_elop_handler<8> {
	template<class T, class U> static void go(T &d, U a)
	{
		d.data()[0] = a.template element<0>();
		d.data()[1] = a.template element<1>();
		d.data()[2] = a.template element<2>();
		d.data()[3] = a.template element<3>();
		d.data()[4] = a.template element<4>();
		d.data()[5] = a.template element<5>();
		d.data()[6] = a.template element<6>();
		d.data()[7] = a.template element<7>();
	}
};

template<> struct assign_elop_handler<6> {
	template<class T, class U> static void go(T &d, U a)
	{
		d.data()[0] = a.template element<0>();
		d.data()[1] = a.template element<1>();
		d.data()[2] = a.template element<2>();
		d.data()[3] = a.template element<3>();
		d.data()[4] = a.template element<4>();
		d.data()[5] = a.template element<5>();
	}
};

template<> struct assign_elop_handler<4> {
	template<class T, class U> static void go(T &d, U a)
	{
		d.data()[0] = a.template element<0>();
		d.data()[1] = a.template element<1>();
		d.data()[2] = a.template element<2>();
		d.data()[3] = a.template element<3>();
	}
};

template<> struct assign_elop_handler<3> {
	template<class T, class U> static void go(T &d, U a)
	{
		d.data()[0] = a.template element<0>();
		d.data()[1] = a.template element<1>();
		d.data()[2] = a.template element<2>();
	}
};

template<> struct assign_elop_handler<2> {
	template<class T, class U> static void go(T &d, U a)
	{
		d.data()[0] = a.template element<0>();
		d.data()[1] = a.template element<1>();
	}
};

template<> struct assign_elop_handler<1> {
	template<class T, class U> static void go(T &d, U a)
	{
		d.data()[0] = a.template element<0>();
	}
};

} // namespace math
} // namespace cpse
